VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim mSymbol  As String
Dim mFirst As ListNode
Dim mRest As ListNode
Public Property Get Symbol() As String
    Symbol = mSymbol
End Property
Public Property Get CAR() As ListNode
    If Not mFirst Is Nothing Then Set CAR = mFirst
End Property
Public Property Get CDR() As ListNode
    If Not mRest Is Nothing Then Set CDR = mRest
End Property
Public Function StringRep() As String
 Dim MyString
 MyString = mSymbol
 If Not mFirst Is Nothing Then
    MyString = "(" + MyString + mFirst.StringRep
    If Not mRest Is Nothing Then
        MyString = MyString + " " + mRest.StringRep
    End If
    MyString = MyString + ")"
 Else
    If Not mRest Is Nothing Then
        MyString = MyString + " " + mRest.StringRep
    End If

 End If
 StringRep = MyString

End Function

Public Sub ReadIn(InString As String)
Dim C$
If InString = "" Then Exit Sub
C$ = Left$(InString, 1): R$ = Mid$(InString, 2)
Select Case C$
    Case "("
        Set mFirst = New ListNode
        mFirst.ReadIn R$
        InString = R$
        Exit Sub
    Case ")"
        InString$ = R$
        Exit Sub
    Case Else
        mSymbol = mSymbol + C$
        'Get next char
        C$ = Left$(R$, 1): R$ = Mid$(R$, 2)
        'If C$ = "(" Then 'push down a level
        While C$ <> " " And C$ <> ")"
            mSymbol = mSymbol + C$
            C$ = Left$(R$, 1): R$ = Mid$(R$, 2)
        Wend
        If C$ = " " Then 'finish and go to next
            If R$ <> ")" Then
                Set mRest = New ListNode
                mRest.ReadIn R$
            End If
        End If
        
End Select
InString = R$
End Sub
